      program bcast
      implicit none
      include 'mpif.h'

      double precision    val       
      integer niter
      integer com, nproc, myid, ierr, ip

      com = MPI_COMM_WORLD
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( com, nproc, ierr )
      call MPI_COMM_RANK( com, myid, ierr )


      if (myid.eq.0) then
!  input values
         write(6,*)'number of iterations (integer) ?  '
         read(5,*) niter
         write(6,*)'start value (double precision) ?  '
         read(5,*) val
         write(6,*) 'input values are : ',niter,val
      end if

!  distribute input values to all processes
      if (myid.eq.0) then
        do ip = 1 , nproc-1
            call MPI_SEND( niter, 1, MPI_INTEGER, ip, 0, com, ierr )
            call MPI_SEND( val, 1, MPI_DOUBLE_PRECISION, ip, 1, 
     :                     com, ierr )
        end do
      else
         call MPI_RECV( niter, 1, MPI_INTEGER, 0, 0, com,
     :                  MPI_STATUS_IGNORE , ierr )
         call MPI_RECV( val, 1, MPI_DOUBLE_PRECISION, 0, 1, com, 
     :                  MPI_STATUS_IGNORE, ierr )
      end if

!  Use MPI_BCAST for distributing input values
!  Syntax:
!  MPI_BCAST( buf, count, datatype, root, comm, ierror )
      write(6,*) 'on proc. ',myid,' input values are', niter, val

      call MPI_FINALIZE( ierr )

      stop
      end













