      program p2p_vector
      implicit none
!  FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer    ierr, nproc, myid, req, ntest,
     :           i, nsend, nrecv, startsend, startrecv
      logical flag
      double precision vec(10000)

!  initialize MPI, get nproc (# of procs) and myid (local proc. id)
      call MPI_INIT( ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, nproc, ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )

 111  format(i3,'>> initial:    vec=',10f3.0)
           
      
      if (myid.eq.0) then
         do i = 1 , 10
            vec(i) = 0.d0 
         end do
         write(6,111)myid,vec(1:10)
         startrecv = 2; nrecv = 3
         call MPI_IRECV(vec(startrecv), nrecv, MPI_DOUBLE_PRECISION, 
     :                 MPI_ANY_SOURCE, MPI_ANY_TAG, 
     :                 MPI_COMM_WORLD, req, ierr)
         ntest = 0
         do while (flag.eqv..false.)
            ntest = ntest+1
            call MPI_TEST(req,flag,MPI_STATUS_IGNORE,ierr)
!            write(6,*) 'flag = ',flag
         end do
         write(6,113)myid,ntest,vec(1:10)
 113     format(i3,'>> after',i10,' tests revc: vec=',10f3.0)
      end if
      if (myid.eq.1) then
         startsend = 5; nsend = 3
! initialize a large array to delay the send call
         do i = 1 , 10000
            vec(i) = i
         end do
         write(6,111)myid,vec(1:10)
         call MPI_SEND( vec(startsend), nsend, MPI_DOUBLE_PRECISION, 0, 
     :                  11, MPI_COMM_WORLD, ierr )
      end if

      call MPI_FINALIZE( ierr )

      stop
      end



 
