      program timing
      implicit none
c FORTRAN MPI-INCLUDE-file
      include 'mpif.h'
      integer nsmpmx
      parameter (nsmpmx = 100)
c-----------------------------------------------------------------------
c              local variables
c-----------------------------------------------------------------------
      integer n1max, n2max
      parameter (n2max = 2**15, n1max = 2**9)
      real*8          a(n1max*n2max+26), x(n1max+26), y(n2max+26)
      real*8          one, null
      real*8          rtc, t1, t2, speed, speedv, ts
      integer         n1, n2, nt, l, ne, nel, neh, nop, nrep,
     :                n1l, n1h, n1step, n2l, n2h, n2step,
     :                i1, is1, i2, is2, lda, ierr, pnamelen
      character*(40) pname
c-----------------------------------------------------------------------
c              executable statements
c-----------------------------------------------------------------------
      call MPI_INIT( ierr )
      call MPI_GET_PROCESSOR_NAME( pname, pnamelen, ierr )
      write(6,1000) pname
 1000    format(//3x,'dgemv on one processor  ',a,//
     :           /3x,'        n1       n2       nrep',   
     :         '      total time   time/dgemv   speed '/)

c      read(5,*) is1,n1l,n1h,n1step
c      read(5,*) is2,n2l,n2h,n2step
c      read(5,*) lda

      is2 = 1
      n2l = 3
      n2h = 15
      n2step = 1

      is1 = 0
      n1l = 480
      n1h = 480
      n1step = 40

      lda = n1h

      speedv = 100.
      ts = .5

      do i2 = n2l , n2h , n2step
      do i1 = n1l , n1h , n1step

         if (is1.eq.0) then
            n1 = i1
         else
            n1 = 2**i1
         end if
         if (is2.eq.0) then
            n2 = i2
         else
            n2 = 2**i2
         end if
         nt = n1*n2
         if (lda.gt.n1max) then
            write(6,*) 'lda too large'
            stop
         end if
         if (lda.lt.n1)then
            write(6,*) 'lda smaller than n2'
            stop
         end if
         if (n1.gt.n1max) then
            write(6,*) 'n1 too large'
            stop
         end if
         if (n2.gt.n2max) then
            write(6,*) 'n2 too large'
            stop
         end if
         nop = real(2*nt)
         nrep = 10 + speedv*1.e6*ts/real(nop)
         one = 1.
         null = 0.
         call inimat(n2*lda,a)
         call inimat(n1,x)
c         call inimat(n2,y)
         t1 = MPI_WTIME() 
         do l = 1 , nrep
            call dgemv('t',n1,n2,one,a,lda,x,1,null,y,1)
         end do
         t2 = MPI_WTIME()  - t1
         speed = 0
         if (t2.gt.0.) speed = nrep*nop*1.0e-6 / real(t2)
         write(6,1001)n1,n2,nrep,t2, t2/(2*nrep),speed
 1001 format(3x,3i10,2e13.2,f13.4)
      end do
      end do
      call MPI_FINALIZE (ierr)

      stop
      end

      subroutine inimat(n1,a)
      implicit none
      integer n1, i
      real*8  a(*)
      do 1 i = 1 , n1
         a(i) = 1+i*0.1e-6
 1    continue
      return
      end










