      subroutine dist_index( n, np, firstind )
c     ===============================
c  all variables should be explicitely declared !
      implicit none 
c
      integer           n, np, firstind(0:*)
c
c  +-------------+----------------+------------------------------------+
c  |  parameter  |  input/output  |  description                       |
c  +-------------+----------------+------------------------------------+
c  |  n          |  input         |  indexrange to be distributed      |
c  |  np         |  input         |  number of procs for distribution  |
c  |  firstind   |  output        |  vector, firstind(ip) contains     |
c  |             |                |  first global index on proc ip     |
c  +-------------+----------------+------------------------------------+
c  |                                                                   |
c  |  Purpose of this subroutine is to calculate the value of the first|
c  |  global index for each processor an to store these values into    |
c  |  integer vector firtstind                                         |
c  |                                                                   |
c  +-------------------------------------------------------------------+
c  |  ruler                                                            |
c  |5 7 10   15   20   25   30   35   40   45   50   55   60   65   70 | 
c  ++-+--+----+----+----+----+----+----+----+----+----+----+----+----+-+
c
c  local variables
      integer           nl, ip, i
      
      nl = (n+np-1) / np
      firstind( 0 ) = 1
      do ip = 1 , np
         firstind(ip) = min(firstind(ip-1)+nl,n+1)
      end do
      return
      end
