      program piprec
      implicit none
      include 'mpif.h'

      double precision  pia, piexact, lo, hi, width, delt, t, t1, r, 
     :                  f, numint
      integer  i, n, ndom, nl, ierr

      piexact = 3.14159265358979323846264338327950288419d0 
      call MPI_INIT( ierr )
!  input of n, ndom
      write(6,*)'number of strips ?  '       
      read(5,*) n
      write(6,*)'number of intervals?  '
      read(5,*) ndom

      write(6,1001) n, ndom
 1001 format(//'calculation of pi using numerical integration of '
     :         'SQRT(1-x**2)'
     :        /'number of strips    : ',i20,
     :        /'number of intervals : ',i20)
!  numerical approximation
      t = MPI_Wtime() 
      width = 1.d0/ndom
      pia = 0.0d0
      do i = 1 , ndom
         t1 = MPI_Wtime()
         hi = i * width
         lo = hi - width
         nl = n * (f(lo) - f(hi))+1
         delt = (hi-lo)/nl
         pia = numint(lo,delt,nl,pia)
         t1 = MPI_Wtime()-t1
         print '(a,i3,a,i10,a,e11.4,a)',
     :  'domain',i,'  with',nl,'  strips in',t1,'  s'
      end do
      t = MPI_Wtime() - t
      r = n/t*1.e-6


!  output of results
      write(6,1111)piexact, pia, abs(pia-piexact)
 1111 format(/'pi exact              = ',f20.14,
     :       /'pi estimated          = ',f20.14,
     :       /'error                 = ',e20.3)
      print  '(a,e11.4,a,f8.2,a)'
     :          ,'time : ',t,' s , rate :',r,' [Mstrips/s]'
!      print  '(F10.6 ,F6.2)',t,r
      call MPI_FINALIZE( ierr )
      stop
      end
